var util = require('util');

var deleteProp = [
	"connection_bandwidth_received_last_minute_total",
	"connection_bandwidth_received_last_second_total",
	"connection_bandwidth_sent_last_minute_total",
	"connection_bandwidth_sent_last_second_total",
	"connection_bandwidth_sent_last_minute_total",
	"connection_bytes_received_total",
	"connection_bytes_sent_total",
	"connection_packets_received_total",
	"connection_packets_sent_total",
	"connection_filetransfer_bandwidth_received",
	"connection_filetransfer_bandwidth_sent",
	"client_badges",
	"client_country",
	"client_is_channel_commander",
	"client_created",
	"client_flag_avatar",
	"client_talk_request_msg",
	"client_talk_request",
	"client_lastconnected",
	"client_totalconnections",
	"client_version_sign",
	"client_away_message",
	"client_security_hash",
	"client_meta_data",
	"client_version",
	"client_needed_serverquery_view_power",
	"client_nickname_phonetic",
	"client_is_priority_speaker",
	"client_month_bytes_uploaded",
	"client_month_bytes_downloaded",
	"client_total_bytes_uploaded",
	"client_total_bytes_downloaded",
	"client_default_token",
	"client_base64HashClientUID",
	"client_default_channel",
	"client_icon_id",
	"targetmode",
	"msg",
	"client_login_name",
	"client_platform",
	"client_input_muted",
	"client_output_muted",
	"client_outputonly_muted",
	"client_input_hardware",
	"client_output_hardware",
	"client_is_recording",
	"client_channel_group_id",
	"client_servergroups",
	"client_away",
	"client_is_talker",
	"client_type",
	"client_channel_group_inherited_channel_id",
	"connection_client_ip",
	"client_idle_time",
	"client_talk_power",
	"client_description",
	"connection_connected_time"
];
var translateProp = {
	'client_unique_identifier': 'uid',
	'client_database_id': 'dbid',
	'client_nickname': 'name',
	'client_status': 'status',
	'clid': 'clid',
	'cid': 'cid',
	'invokerid': 'clid',
	'invokername': 'name',
	'invokeruid': 'uid'
}

module.exports = function(event, data, next) {
    var bot = this;
    
    function User(userData) {
	    var self = this;
	    self.info = {};
	    self.detail = {};
	    
	    for(var prop in userData) {
	        if(deleteProp.indexOf(prop) > -1) {
	        	self.detail[prop] = userData[prop];
	        	continue;
			}
	        
	        if(translateProp.hasOwnProperty(prop)) {
	            self.info[translateProp[prop]] = userData[prop];
	        }
	    }
	    
	    User.prototype.respond = function() {
	        var args = Array.prototype.slice.call(arguments);
			for(var i=0; i<args.length; i++){
				if(typeof args[i] == 'object') args[i] = util.inspect(args[i]);
			}
			
			bot.sendCommand('sendtextmessage', {'targetmode': 1, 'target': self.info.clid, 'msg': args.join(' ')});
			return this;
		}
		
		User.prototype.poke = function() {
			var args = Array.prototype.slice.call(arguments);
			for(var i=0; i<args.length; i++){
				if(typeof args[i] == 'object') args[i] = util.inspect(args[i]);
			}
			
			bot.sendCommand('clientpoke', {'clid': self.info.clid, 'msg': args.join(' ')});
			return this;
		}
		
		User.prototype.move = function(cid) {
			bot.sendCommand('clientmove', {'clid': self.info.clid, 'cid': cid});
			return this;
		}
	}
    
    data.user = new User(data, bot);
    next();
}

module.exports.init = function() {
    var bot = this;
    
    /*this.findUser = function(name, callbackFunction) {
        bot.sendCommand('clientfind', {'pattern': String(name)}, function(err, res, raw) {
            if(err && typeof callbackFunction == 'function') return callbackFunction(null);
            else if(err) return callbackFunction(null);
            
            var data = res;
            
            bot.sendCommand('clientinfo', {'clid': res.clid}, function(err, res, raw) {
                if(err && typeof callbackFunction == 'function') return callbackFunction(null);
                else if(err) return callbackFunction(null);
                
                res.clid = data.clid;
                if(typeof callbackFunction == 'function') callbackFunction(new User(res), bot);
            });
        });
    }*/
}